{
  description = "A Nix-flake-based Rust development environment";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    nixpkgs-stable.url = "github:NixOS/nixpkgs/0ef56bec7281e2372338f2dfe7c13327ce96f6bb";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs =
    { self
    , nixpkgs
    , nixpkgs-stable
    , flake-utils
    }:
    flake-utils.lib.eachDefaultSystem
      (system:
      let
        overlays = [ ];
        pkgs = import nixpkgs {
          inherit system overlays;
        };
        pkgs-stable = import nixpkgs-stable {
          inherit system overlays;
        };
        buildInputs = with pkgs; [
          glib
          glibc
          gtk3
          harfbuzz
          libsoup_3
          openssl
          sqlite
          zlib
          pkgs-stable.clang
          pkgs-stable.gzip
          pkgs-stable.coreutils
        ];
      in
      {
        devShells.default = pkgs.mkShell {
          packages = with pkgs;
            [
              fish
              nodejs_20
              unzip
            ]
            ++ buildInputs;

          buildInputs = buildInputs;
          shellHook = ''
            export MALLOC_CONF=thp:always,metadata_thp:always

            npm install
          '';
        };
      });
}
